package yuehaoxitong

import (
	"shylinux.com/x/ice"

	"shylinux.com/x/community/src/yuehaoxitong/model"
)

type plan struct {
	Schedule
	volume     Volume
	reception  reception
	volumeList string `name:"volumeList" role:"void"`
}

func (s plan) Create(m *ice.Message) {
	s.Schedule.Create(m, m.OptionSimple(model.QUEUE_UID, model.VOLUME_UID, model.USER_UID)...)
}
func (s plan) List(m *ice.Message, arg ...string) {
	m.Cmdy(s.reception, arg).Action().Display("").DisplayCSS("")
}
func (s plan) VolumeList(m *ice.Message) {
	s.Tables(m, "LEFT JOIN schedules ON schedules.volume_uid = volumes.uid AND status = 0")
	s.Fields(m, s.AS(s.Key(s.volume, model.UID), model.VOLUME_UID), model.BEGIN_TIME, model.END_TIME, model.STATUS, s.Key(s.Schedule, model.UID)).Orders(m, model.BEGIN_TIME)
	m.Cmdy(s.volume, s.Select, "volumes.queue_uid = ? AND volumes.reception_uid = ? AND end_time > ?", m.Option(model.QUEUE_UID), m.Option(model.RECEPTION_UID), m.Time())
	m.Table(func(value ice.Maps) {
		if value[model.STATUS] == "0" {
			m.PushButton(s.Cancel)
		} else {
			m.PushButton(s.Create)
		}
	})
}

func init() { ice.TeamCtxCmd(plan{}) }
